Panda3D

Public Member Functions | Static Public Member Functions | List of all members
EggMatrixTablePointer Class Reference

This stores a pointer back to an EggXfmSAnim table (i.e. More...

`#include "eggMatrixTablePointer.h"`

Inheritance diagram for EggMatrixTablePointer:

## Public Member Functions
| EggMatrixTablePointer (EggObject *object)
virtual bool | add_frame (const LMatrix4d &mat)
| Appends a new frame onto the end of the data, if possible; returns true if not possible, or false otherwise (e.g. More...
virtual void | do_finish_reparent (EggJointPointer *new_parent)
| Performs the actual reparenting operation by removing the node from its old parent and associating it with its new parent, if any. More...
virtual bool | do_rebuild (EggCharacterDb &db)
| Rebuilds the entire table all at once, based on the frames added by repeated calls to add_rebuild_frame() since the last call to begin_rebuild(). More...
virtual void | extend_to (int num_frames)
| Extends the table to the indicated number of frames. More...
virtual TypeHandle | force_init_type ()
virtual LMatrix4d | get_frame (int n) const
| Returns the transform matrix corresponding to this joint position in the nth frame. More...
virtual double | get_frame_rate () const
| Returns the stated frame rate of this particular joint, or 0.0 if it doesn't state. More...
virtual int | get_num_frames () const
| Returns the number of frames of animation for this particular joint. More...
virtual TypeHandle | get_type () const
virtual EggJointPointer * | make_new_joint (const std::string &name)
| Creates a new child of the current joint in the egg data, and returns a pointer to it. More...
virtual void | optimize ()
| Resets the table before writing to disk so that redundant rows (e.g. More...
virtual void | quantize_channels (const std::string &components, double quantum)
| Rounds the named components of the transform to the nearest multiple of quantum. More...
virtual void | set_frame (int n, const LMatrix4d &mat)
| Sets the transform matrix corresponding to this joint position in the nth frame. More...
virtual void | set_name (const std::string &name)
| Applies the indicated name change to the egg file. More...
virtual void | zero_channels (const std::string &components)
| Zeroes out the named components of the transform in the animation frames. More...
Public Member Functions inherited from EggJointPointer
virtual void | apply_default_pose (EggJointPointer *source_joint, int frame)
| Applies the pose from the indicated frame of the indicated source joint as the initial pose for this joint. More...
virtual void | expose (EggGroup::DCSType dcs_type)
| Flags the joint with the indicated DCS flag so that it will be loaded as a separate node in the player. More...
virtual void | move_vertices_to (EggJointPointer *new_joint)
| Moves the vertices assigned to this joint into the other joint (which should be of the same type). More...
Public Member Functions inherited from EggBackPointer
virtual bool | has_vertices () const
| Returns true if there are any vertices referenced by the node this points to, false otherwise. More...
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type. More...
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly. More...
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type. More...
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from EggJointPointer
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from EggBackPointer
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96. More...

## Additional Inherited Members
Public Attributes inherited from TypedObject
| get_type

## Detailed Description

This stores a pointer back to an EggXfmSAnim table (i.e.

an <Xfm$Anim_S$> entry in an egg file), corresponding to the animation data from a single bundle for this joint.

Definition at line 30 of file eggMatrixTablePointer.h.

## Member Function Documentation

## ◆ add_frame()

bool EggMatrixTablePointer::add_frame | ( | const LMatrix4d & | mat | ) |
| virtual

Appends a new frame onto the end of the data, if possible; returns true if not possible, or false otherwise (e.g.

for a static joint).

Reimplemented from EggJointPointer.

Definition at line 141 of file eggMatrixTablePointer.cxx.

## ◆ do_finish_reparent()

void EggMatrixTablePointer::do_finish_reparent | ( | EggJointPointer * | new_parent | ) |
| virtual

Performs the actual reparenting operation by removing the node from its old parent and associating it with its new parent, if any.

Implements EggJointPointer.

Definition at line 154 of file eggMatrixTablePointer.cxx.

## ◆ do_rebuild()

bool EggMatrixTablePointer::do_rebuild | ( | EggCharacterDb & | db | ) |
| virtual

Rebuilds the entire table all at once, based on the frames added by repeated calls to add_rebuild_frame() since the last call to begin_rebuild().

Until do_rebuild() is called, the animation table is not changed.

The return value is true if all frames are acceptable, or false if there is some problem.

Reimplemented from EggJointPointer.

Definition at line 183 of file eggMatrixTablePointer.cxx.

## ◆ extend_to()

void EggMatrixTablePointer::extend_to | ( | int | num_frames | ) |
| virtual

Extends the table to the indicated number of frames.

Reimplemented from EggBackPointer.

Definition at line 87 of file eggMatrixTablePointer.cxx.

## ◆ get_frame()

LMatrix4d EggMatrixTablePointer::get_frame | ( | int | n | ) | const
| virtual

Returns the transform matrix corresponding to this joint position in the nth frame.

Implements EggJointPointer.

Definition at line 109 of file eggMatrixTablePointer.cxx.

References get_num_frames().

## ◆ get_frame_rate()

double EggMatrixTablePointer::get_frame_rate | ( |  | ) | const
| virtual

Returns the stated frame rate of this particular joint, or 0.0 if it doesn't state.

Reimplemented from EggBackPointer.

Definition at line 63 of file eggMatrixTablePointer.cxx.

## ◆ get_num_frames()

int EggMatrixTablePointer::get_num_frames | ( |  | ) | const
| virtual

Returns the number of frames of animation for this particular joint.

Implements EggJointPointer.

Definition at line 75 of file eggMatrixTablePointer.cxx.

Referenced by get_frame().

## ◆ make_new_joint()

EggJointPointer * EggMatrixTablePointer::make_new_joint | ( | const std::string & | name | ) |
| virtual

Creates a new child of the current joint in the egg data, and returns a pointer to it.

Implements EggJointPointer.

Definition at line 274 of file eggMatrixTablePointer.cxx.

## ◆ optimize()

void EggMatrixTablePointer::optimize | ( |  | ) |
| virtual

Resets the table before writing to disk so that redundant rows (e.g.

i { 1 1 1 1 1 1 1 1 }) are collapsed out.

Reimplemented from EggJointPointer.

Definition at line 218 of file eggMatrixTablePointer.cxx.

## ◆ quantize_channels()

void EggMatrixTablePointer::quantize_channels | ( | const std::string & | components,
|  | double | quantum
| ) |  |
| virtual

Rounds the named components of the transform to the nearest multiple of quantum.

Reimplemented from EggJointPointer.

Definition at line 250 of file eggMatrixTablePointer.cxx.

References TypedObject::is_of_type().

## ◆ set_frame()

void EggMatrixTablePointer::set_frame | ( | int | n,
|  | const LMatrix4d & | mat
| ) |  |
| virtual

Sets the transform matrix corresponding to this joint position in the nth frame.

Implements EggJointPointer.

Definition at line 131 of file eggMatrixTablePointer.cxx.

## ◆ set_name()

void EggMatrixTablePointer::set_name | ( | const std::string & | name | ) |
| virtual

Applies the indicated name change to the egg file.

Reimplemented from EggBackPointer.

Definition at line 292 of file eggMatrixTablePointer.cxx.

## ◆ zero_channels()

void EggMatrixTablePointer::zero_channels | ( | const std::string & | components | ) |
| virtual

Zeroes out the named components of the transform in the animation frames.

Reimplemented from EggJointPointer.

Definition at line 228 of file eggMatrixTablePointer.cxx.

The documentation for this class was generated from the following files:

- pandatool/src/eggcharbase/eggMatrixTablePointer.h
- pandatool/src/eggcharbase/eggMatrixTablePointer.cxx